<?php
include "basic_session.php";

SessionStart();

@$start = $_GET['start'];
@$cel = $_GET['cel'];

$state = SessionRead("state");
$player = SessionRead("player");
$machine = SessionRead("machine");

if ($start == "x" || $start == "o") {
	SessionPop("player");
	SessionPop("machine");
	SessionPop("state");
	$player = $start;
	if ($player == "x") $machine = "o";
	else {
		$player = "o";
		$machine = "x";
	}
	$state = "          ";
	$ale = rand(0,9);
	if ($ale < 5) $state = machinePlay($state,$machine);

	SessionPush("player",$player);
	SessionPush("machine",$machine);
	SessionPush("state",$state);
}
else if ($cel != "" && $cel!=null && substr($cel,0,1)=="c") {
	$cel = substr($cel,1,1);
	$state = SessionRead("state");
	$player = SessionRead("player");
	$machine = SessionRead("machine");
	$state = replace($state,$cel,$player);
	SessionPush("state",$state);
	$state = verificaVitoria($state, $player, "v");
	if (substr($state,9,1) == " ") {
		$state = machinePlay($state,$machine);
		$state = verificaVitoria($state, $machine, "p");
		SessionPush("state",$state);
		}
	$spaces = contaEspacos($state);
	if ($spaces == 0 && substr($state,9,1) == " ") {
		$state = replace($state,9,"e");
	}

}

print($state);

function verificaVitoria($state, $p, $v) {
	$c = array (
	substr($state,0,1),
	substr($state,1,1),
	substr($state,2,1),
	substr($state,3,1),
	substr($state,4,1),
	substr($state,5,1),
	substr($state,6,1),
	substr($state,7,1),
	substr($state,8,1));

	$vp = array(	0,1,2,
			3,4,5,
			6,7,8,
			0,3,6,
			1,4,7,
			2,5,8,
			0,4,8,
			2,4,6	);

	// Testa padroes de vitria
	for ($i=0; $i<24; $i+=3) {
		if ($c[$vp[$i]] == $p && $c[$vp[$i+1]] == $p && $c[$vp[$i+2]] == $p) {
			$np = strtoupper($p);
			$state = replaceIncond($state,$vp[$i],$np);
			$state = replaceIncond($state,$vp[$i+1],$np);
			$state = replaceIncond($state,$vp[$i+2],$np);
			$state = replaceIncond($state,9,$v);
			break;
		}
	}

	return $state;
}

function replace($base, $pos, $value) {
	$final = $base;
	$el = substr($base,$pos,1);
	if ($el != "x" && $el != "X" && $el != "o" && $el != "O" ) {
		$ini = substr($base,0,$pos);
		$end = substr($base,$pos+1);
		$final = $ini . $value . $end;
	}
	return $final;
}

function replaceIncond($base, $pos, $value) {
	$final = $base;
	$el = substr($base,$pos,1);
	$ini = substr($base,0,$pos);
	$end = substr($base,$pos+1);
	$final = $ini . $value . $end;
	return $final;
}

function contaEspacos($state) {
	// Conta espaos
	$spaces = 0;
	for ($i=0; $i <=8; $i++) {
		$value = substr($state,$i,1);
		if ($value == " ") $spaces++;
	}
	return $spaces;
}


function machinePlay($state,$machine) {
	$spaces = contaEspacos($state);

	if ($spaces == 0) return $state;
	else if ($spaces == 1) {
		for ($i=0; $i <=8; $i++) {
			$value = substr($state,$i,1);
			if ($value == " ") {
				$state = replace($state,$i,$machine);
				break;
			}
		}
	}
	else {
		$i = 0;
		$limit = ($spaces/2)+1;
		while(1) {
			$value = substr($state,$i,1);
			if ($value == " ") {
				$ale = rand(0,$spaces + 1);
				if ($ale < 5) {
					$state = replace($state,$i,$machine);
					break;
				}
			}
			$i++;
		}
	}
	return $state;
}

?>

